import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Ball here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ball extends Actor
{
    /**
     * Act - do whatever the Ball wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    static int counter=0;
    public void act() 
    {
        move(-3);
        lookForPaddle();
        lookForButton();
        lookForWand();
        
        if(atWorldEdge())
        {
                turn(Greenfoot.getRandomNumber(360) -50);
                move(3);
        }
    }
    
    public boolean atWorldEdge()
    {
        if (getX() <= 1 || getX() >= getWorld().getWidth() - 1) {
            return true;
        }
        if (getY() <= 1 || getY() >= getWorld().getHeight() - 1 ) {
            return true;
        } else {
            return false;
        }
    }
    
    public void eat(Class clss)
    {
        Actor actor = getOneIntersectingObject(clss);
        if(actor == null) return;
        getWorld().removeObject(actor);
    }
    
    public boolean canSee(Class clss)
    {
        return (getOneIntersectingObject(clss) != null);
    }
    
    public void lookForButton()
    {
        if(canSee(Button.class))
        {
            eat(Button.class);
            Breakout.c.add(1);
            counter = counter+1;
            if (counter == 11)
            {
                 Greenfoot.stop();
                 Breakout.c.setValue(0);
            }
            turn(Greenfoot.getRandomNumber(360) -50);
            move(3);
        }
    }
    
    public void lookForPaddle()
    {
        if(canSee(Paddle.class))
        {
            setRotation(45);
        }
   }
    public void lookForWand()
    {
        if(canSee(Wand1.class))
        {
            turn(-65);
        }
        if(canSee(Wand2.class))
        {
            turn(67);
        }
        if(canSee(Ecke.class))
        {
            turn(65);
        }
        if(canSee(Ecke2.class))
        {
            turn(-65);
        }
    }
}
